const maxN = 1000000 + 10;
      INF = round(1e18);
type node = record
	pos : longint;
	d : longint;
	best : int64;
end;

var n, i, k, nn, lenBorders, m, _cnt, j : longint;
    a, ans, fenw : array[0 .. maxN] of int64;
    sum, d : int64;
    borders : array[0 .. maxN] of node;

procedure setBorders(index : longint; pos, d : longint; best : int64);
begin
 borders[index].pos := pos;
 borders[index].d := d;
 borders[index].best := best;
end;

function gcd(a, b : int64) : int64;
begin
 while (a > 0) and (b > 0) do
  if a > b then a := a mod b else b := b mod a;
 gcd := a + b;
end;

function max(a, b : int64) : int64;
begin
 if (a > b) then max := a else max := b;
end;

procedure set_val(pos : longint; val : int64);
begin
 while pos > 0 do
  begin
   fenw[pos] := max(fenw[pos], val);
   pos := pos and (pos - 1);
  end;
end;

function get_max(l, r : longint) : int64;
var res : int64;
begin
 if (l > r) then
  begin
   get_max := -INF;
   exit;
  end;
 if (r = 0) then
  begin
   get_max := -INF;
   exit;
  end;
 if (l = 0) then l := 1;
 res := -INF;
 while (l <= n) do
  begin
   res := max(res, fenw[l]);
   l := l + l - (l and (l - 1));
  end;
 get_max := res;
end;

procedure calc(i : longint);
var ind, indBord : longint;
    curAns: int64;
begin
 for ind := 1 to lenBorders - 1 do
  borders[ind].d := gcd(borders[ind].d, a[i]);
 k := 0;
 for ind := 1 to lenBorders - 1 do
  if borders[ind].d = borders[k].d then
   borders[k].best := max(borders[k].best, borders[ind].best) else
  begin
   k := k + 1;
   borders[k] := borders[ind];
  end;
 lenBorders := k + 1;
 if (i >= d) then
  begin
   set_val(i - d, ans[i - d]);
   for indBord := 0 to lenBorders - 1 do
    if (indBord + 1 < lenBorders) and (i - d + 1 >= borders[indBord + 1].pos) then
     begin
      if (borders[indBord + 1].pos - borders[indBord].pos > 1) then
       ans[i] := max(ans[i], borders[indBord].best + borders[indBord].d);
      ans[i] := max(ans[i], ans[borders[indBord + 1].pos - 1] + borders[indBord + 1].d);
     end else
     begin
      curAns := get_max(borders[indBord].pos, i - d);
      ans[i] := max(ans[i], curAns + borders[indBord].d);
      break;
     end;
  end;
 inc(lenBorders);
 setBorders(lenBorders - 1, i, a[i], ans[i]);
end;

begin
 assign(input, 'gcdsis.txt'); reset(input);
 assign(output, 'gcdval.txt'); rewrite(output);
 read(nn, m, d);
 sum := 0;
 for i := 1 to nn do
  begin
   read(_cnt);
   for j := 1 to _cnt do
    begin
     n := n + 1;
     read(a[n]);
     sum := sum + a[n];
    end;             
  end;
 close(input);
 if (d = 1) then
  begin
   writeln(sum);
   close(output);
   halt;
  end;
 lenBorders := 1;
 setBorders(0, 0, 0, 0);

 for i := 1 to n do ans[i] := -INF;
 for i := 0 to n do fenw[i] := -INF;

 for i := 1 to n do
  calc(i);
 writeln(ans[n]);
 close(output);
end.
