#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

ifstream sis("sortsis.txt");
ofstream val("sortval.txt");

int main() {
    int n;
    sis >> n;

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        sis >> a[i];
    }

    auto cc = a;
    sort(cc.begin(), cc.end());
    cc.resize(unique(cc.begin(), cc.end()) - cc.begin());

    for (int& x : a) {
        x = lower_bound(cc.begin(), cc.end(), x) - cc.begin();
    }

    a.resize(unique(a.begin(), a.end()) - a.begin());
    n = a.size();

    vector<vector<int>> pos(cc.size());

    for (int i = 0; i < n; i++) {
        pos[a[i]].push_back(i);
    }

    vector<int> dp(n, 0);

    for (int i = 0; i + 1 < cc.size(); i++) {
        pair<int, int> m1(-1, 0), m2(-1, 0);

        for (int u : pos[i]) {
            auto c = make_pair(dp[u], u);
            if (c > m1) {
                m2 = m1;
                m1 = c;
            } else if (c > m2) {
                m2 = c;
            }
        }

        for (auto p : {m1, m2}) {
            if (p.first == -1) {
                continue;
            }

            for (int v : pos[i + 1]) {
                int add = !(pos[i].size() > 1 && p.second + 1 == v);
                add &= v && a[v - 1] == i;
                dp[v] = max(dp[v], p.first + add);
            }
        }
    }

    int ans = 1e9;
    for (int i : pos.back()) {
        ans = min(ans, n - 1 - dp[i]);
    }

    val << ans + 1 << '\n';

    return 0;
}
